#define __GLMETASEQV2EX_C__

#include "GLMetaseqV2Ex.h"
#include "../OpenGLExtension.h"

#define DEF_DEFAULT_FORMAT "%s%d.mqo"

////////////////////////////////////////////////////////////////////////////////////////////
// vg^Cv錾

void mqoGetDirectory(const char *path_file, char *path_dir);
GLubyte* mqoLoadTexture(char *filename,int *tex_size);
void mqoRegistTexture(GLuint* tex_name,GLubyte* tex_img,int tex_size);
void mqoReleaseTexture(void *pImage);
void mqoSnormal(glPOINT3f A, glPOINT3f B, glPOINT3f C, glPOINT3f *normal);
void mqoReadMaterial(FILE *fp, MQO_MATERIAL M[]);
void mqoReadVertex(FILE *fp, glPOINT3f V[]);
void mqoReadFace(FILE *fp, MQO_FACE F[]);
void mqoReadObject(FILE *fp, MQO_OBJECT_V2 *obj);
MQO_MODEL	 mqoCreateModel(char *filename, double scale);
MQO_SEQUENCE mqoCreateSequence(char *basename, int n_file, double scale);
void mqoCallModel(MQO_MODEL model);
void mqoCallSequence(MQO_SEQUENCE seq, int i);
void mqoDeleteModel(MQO_MODEL model);
void mqoDeleteSequence(MQO_SEQUENCE seq);


void mqoMakeObjectsEx(STR_MQO_OBJECT *mqoobj,MQO_OBJECT_V2 obj[], int n_obj, MQO_MATERIAL M[],int n_mat,
					  double scale,unsigned int alpha) ;
void mqoMakePolygonEx(char *objname,int isVisible,STR_MQO_OBJECT * mqoobj,
					  MQO_FACE F[],int fnum,glPOINT3f V[],glPOINT3f N[],MQO_MATERIAL M[],
					  int n_mat,double facet,double scale,unsigned char alpha) ;
int mqoReadBVertex(FILE *fp,glPOINT3f V[]) ;
GLubyte* mqoLoadTextureEx(char *texfile,char *alpfile,int *tex_size,unsigned char alpha) ;


//byte orderϊ
void endianConverter(void *addr,unsigned int size) {
	unsigned int pos ;
	char c;
	if( size <= 1 ) return ;
	for( pos = 0 ; pos < size/2 ; pos++ ) {
		c = *(((char *)addr)+pos) ;
		*(((char *)addr)+pos) = *(((char *)addr)+(size-1 - pos)) ;
		*(((char *)addr)+(size-1 - pos)) = c ;
	}
}
void TGAHeaderEndianConverter(	STR_TGA_HEAD *tgah ) {
	endianConverter(&tgah->color_map_entry,sizeof(tgah->color_map_entry)) ;
	endianConverter(&tgah->x,sizeof(tgah->x)) ;
	endianConverter(&tgah->y,sizeof(tgah->y)) ;
	endianConverter(&tgah->width,sizeof(tgah->width)) ;
	endianConverter(&tgah->height,sizeof(tgah->height)) ;
}

int l_texPoolnum ;
STR_TEXTURE_POOL l_texPool[MAX_TEXTURE] ;
void mqoClearTexturePool() ;

int l_GLMetaseqInitialized = 0 ; // tO

//
//argInit()̌ɌĂ΂ȂƂƓȂB
void GLMetaseqInitialize() {
	memset(l_texPool,0,sizeof(l_texPool)) ;
	l_texPoolnum = 0 ;

	g_isVBOSupported = IsExtensionSupported("GL_ARB_vertex_buffer_object") ;
#ifdef WIN32
	glGenBuffersARB = NULL ;
	glBindBufferARB = NULL ;
	glBufferDataARB = NULL ;
	glDeleteBuffersARB = NULL ;

//	g_isVBOSupported = 0 ;
	if( g_isVBOSupported ) {
		printf("OpenGL : _obt@T|[gĂ遨gp\n") ;
		// GL ֐̃|C^
		glGenBuffersARB = (PFNGLGENBUFFERSARBPROC) wglGetProcAddress("glGenBuffersARB");
		glBindBufferARB = (PFNGLBINDBUFFERARBPROC) wglGetProcAddress("glBindBufferARB");
		glBufferDataARB = (PFNGLBUFFERDATAARBPROC) wglGetProcAddress("glBufferDataARB");
		glDeleteBuffersARB = (PFNGLDELETEBUFFERSARBPROC) wglGetProcAddress("glDeleteBuffersARB");
	}
#endif
	l_GLMetaseqInitialized = 1 ;

}
//gpȈ
void GLMetaseqClear() {
	mqoClearTexturePool() ;
}


//eNX`v[
//eNX`܂ǂݍ܂ĂȂΓǂݍ݁AeNX`o^
//łɓǂݍ܂ĂΓo^̂ԂB
GLuint mqoSetTexturePool(char *texfile,char *alpfile,unsigned char alpha) 
{
	int pos ;
	GLubyte *image ;
	for( pos = 0 ; pos < l_texPoolnum ; pos++ ) {
		if( alpha != l_texPool[pos].alpha ) {
			continue ;
		}
		if( texfile != NULL ) {
			if( strcmp(texfile,l_texPool[pos].texfile) != 0 ) {
				continue ;
			}
		}
		if( alpfile != NULL ) {
			if( strcmp(alpfile,l_texPool[pos].alpfile) != 0 ) {
				continue ;
			}
		}
		break ;
	}
	if( pos < l_texPoolnum ) { //łɓǂݍݍς
		return  l_texPool[pos].texture_id ;
	}
	if( MAX_TEXTURE <= pos ) {
		printf("%s:mqoSetTexturePool eNX`ǂݍݗ̈s\n",__FILE__) ;
		return -1 ;
	}
	image = mqoLoadTextureEx(texfile,alpfile,&l_texPool[pos].texsize,alpha) ;
	if( image == NULL ) {
		return -1 ;
	}

	if( texfile != NULL ) strncpy(l_texPool[pos].texfile,texfile,MAX_PATH) ;
	if( alpfile != NULL ) strncpy(l_texPool[pos].alpfile,alpfile,MAX_PATH) ;
	l_texPool[pos].alpha = alpha ;

	glPixelStorei(GL_UNPACK_ALIGNMENT,4);
	glPixelStorei(GL_PACK_ALIGNMENT,4);
	glGenTextures(1,&l_texPool[pos].texture_id);		// eNX`𐶐
	glBindTexture(GL_TEXTURE_2D,l_texPool[pos].texture_id);	// eNX`̊蓖

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, l_texPool[pos].texsize, l_texPool[pos].texsize,
					0, GL_RGBA, GL_UNSIGNED_BYTE, image);
	l_texPoolnum = pos+1 ;
	//o^΁Aǂݍ񂾃obt@͕sv
	free(image) ;

	return l_texPool[pos].texture_id;
}
//eNX`v[̊J
void mqoClearTexturePool()
{
	int pos ;
	for( pos = 0 ; pos < l_texPoolnum ; pos++ ) {
		glDeleteTextures(1, &l_texPool[pos].texture_id);			// eNX`폜
	}

	memset(l_texPool,0,sizeof(l_texPool)) ;
	l_texPoolnum = 0 ;

}
/*=========================================================================
y֐zmqoLoadTextureEx
yprzt@CeNX`摜쐬
yz
		*texfile	t@C
		*alpfile	At@t@C
		*tex_size	eNX`̃TCYiӂ̒jԂ

yߒlzeNX`摜ւ̃|C^isNULLj
ydlz24bitrbg}bv,8,24,32bitsf`
		TCÝuӂ2n̐`vɌ
		libjpeg,libpngiOCujLJPEG,PNG̓ǂݍ݉\
=========================================================================*/

GLubyte* mqoLoadTextureEx(char *texfile,char *alpfile,int *tex_size,unsigned char alpha)
{
	FILE *fp;
	size_t namelen ;
	char ext[4];
	char wbuf[3];
	int isTGA ;
	int isPNG ;
	int isJPEG ;
	int other ;
	int	y,x,size;
	int fl;
	char *filename[2] ;
	int width[2] ;
	int sts ;
	STR_TGA_HEAD tgah;
	GLubyte	*pImage, *pRead;

#if DEF_USE_LIBJPEG
	struct jpeg_decompress_struct cinfo;
	struct jpeg_error_mgr jerr;
	JSAMPARRAY jpegimage;
#endif
#if DEF_USE_LIBPNG
	unsigned char **pngimage ;
	unsigned long   pngwidth, pngheight;
	int				pngdepth ;
	int             color_type ;
#endif

	filename[0] = texfile ;
	filename[1] = alpfile ;
	width[0] = -1 ;
	width[1] = -1 ;
	pImage = NULL ;
	fp = NULL ;
	sts = 0 ;
#if DEF_USE_LIBJPEG
	jpegimage = NULL ;
#endif
#if DEF_USE_LIBPNG
	pngimage = NULL ;
#endif
	size = - 1;
	for( fl = 0 ; fl < 2 ; fl++ ) {//eNX`fl=0    At@fl=1
		if( filename[fl] == NULL ) continue ;
		namelen = strlen(filename[fl]) ;
		ext[0] = tolower(filename[fl][namelen-3]) ;
		ext[1] = tolower(filename[fl][namelen-2]) ;
		ext[2] = tolower(filename[fl][namelen-1]) ;
		ext[3] = 0x00 ;
		isTGA = (strcmp(ext,"tga")==0)?1:0 ;
		isPNG = (strcmp(ext,"png")==0)?1:0 ;
		isJPEG = (strcmp(ext,"jpg")==0)?1:0 ;
		/* */
		if( (! isTGA) && (! isPNG) &&(! isJPEG) ) {
			filename[fl][namelen-3] = 'b' ;
			filename[fl][namelen-2] = 'm' ;
			filename[fl][namelen-1] = 'p' ;
		}
		/* */
		if( fl == 1 ) { //At@̓ǂݍ݂͂sf`oromf
			if( ! (isTGA || isPNG) ) {
				printf("At@̃t@CɑΉłȂ%s\n",filename[fl]) ;
				break ;
			}
		}
		if( fp != NULL ) fclose(fp) ;
		if ( (fp=fopen(filename[fl],"rb"))==NULL ) {
			printf("%s:eNX`ǂݍ݃G[[%s]\n",__FILE__,filename[fl]) ;
			continue ;
		}
		// wb_̃[h
		if( isTGA ) {
			fread(&tgah,sizeof(STR_TGA_HEAD),1,fp);
#if DEF_IS_LITTLE_ENDIAN
#else
			TGAHeaderEndianConverter(&tgah) ;
#endif
			size = width[fl] = tgah.width ;
		}
		if( isJPEG ) {
#if DEF_USE_LIBJPEG
			unsigned int i ;
			cinfo.err = jpeg_std_error( &jerr );
			jpeg_create_decompress( &cinfo );	//𓀗p쐬
			jpeg_stdio_src( &cinfo, fp );		//ǂݍ݃t@Cw
			jpeg_read_header( &cinfo, TRUE );	//jpegwb_ǂݍ
			jpeg_start_decompress( &cinfo );	//𓀊Jn

			if( cinfo.out_color_components == 3 && cinfo.out_color_space == JCS_RGB ) {
				if( jpegimage != NULL ) {
					for (i = 0; i < cinfo.output_height; i++) free(jpegimage[i]);            // ȉQs͂Qz܂
					free(jpegimage);
				}
				//ǂݍ݃f[^z̍쐬
				jpegimage = (JSAMPARRAY)malloc( sizeof( JSAMPROW ) * cinfo.output_height );
				for ( i = 0; i < cinfo.output_height; i++ ) {
					jpegimage[i] = (JSAMPROW)malloc( sizeof( JSAMPLE ) * cinfo.out_color_components * cinfo.output_width );
				}
				//𓀃f[^ǂݍ
				while( cinfo.output_scanline < cinfo.output_height ) {
					jpeg_read_scanlines( &cinfo,
						jpegimage + cinfo.output_scanline,
						cinfo.output_height - cinfo.output_scanline
					);
				}
				size = width[fl] = cinfo.output_width ;
			}

			jpeg_finish_decompress( &cinfo );	//𓀏I
			jpeg_destroy_decompress( &cinfo );	//𓀗p
			if( !(cinfo.out_color_components == 3 && cinfo.out_color_space == JCS_RGB) ) {
				printf("JPEG ΉłȂtH[}bg%s\n",filename[fl]) ;
			}
#else
			printf("̃eNX`͑ΉłȂtH[}bg%s\n",filename[fl]) ;
			continue ;
#endif
		}
		if( isPNG ) {
#if DEF_USE_LIBPNG
			png_structp     png_ptr;
			png_infop       info_ptr;
			int             bit_depth, interlace_type;
			unsigned int             i ;
			int j,k;
			png_ptr = png_create_read_struct(                       // png_ptr\̂mہE܂
							PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
			info_ptr = png_create_info_struct(png_ptr);             // info_ptr\̂mہE܂
			png_init_io(png_ptr, fp);                               // libpngfpm点܂
			png_read_info(png_ptr, info_ptr);                       // PNGt@C̃wb_ǂݍ݂܂
			png_get_IHDR(png_ptr, info_ptr, &pngwidth, &pngheight,        // IHDR`N擾܂
							&bit_depth, &color_type, &interlace_type,
							&j,&k);
			if( pngimage != NULL ) {
				for (i = 0; i < pngheight; i++) free(pngimage[i]);            // ȉQs͂Qz܂
				free(pngimage);
			}
			pngimage = (png_bytepp)malloc(pngheight * sizeof(png_bytep)); // ȉRs͂Qzmۂ܂
			i = png_get_rowbytes(png_ptr, info_ptr) ;
			pngdepth = i / pngwidth ;
			for (i = 0; i < pngheight; i++)
					pngimage[i] = (png_bytep)malloc(png_get_rowbytes(png_ptr, info_ptr));
			png_read_image(png_ptr, pngimage);                         // 摜f[^ǂݍ݂܂

			png_destroy_read_struct(                                // Q̍\̂̃܂
	        &png_ptr, &info_ptr, (png_infopp)NULL);
			size = width[fl] = pngwidth ;
#else
			printf("̃eNX`͑ΉłȂtH[}bg%s\n",filename[fl]) ;
			continue ;
#endif
		}
		if( width[fl] == -1 ) {//RR܂łăTCYw肳ĂȂ@@rbg}bv
			fseek(fp,14+4,SEEK_SET);		// 摜i[Ăʒu܂ŃV[N
			fread(&size,sizeof(int),1,fp);	// BiWidth̏񂾂擾
			fseek(fp,14+40,SEEK_SET);		// ff[^i[Ăʒu܂ŃV[N
#if DEF_IS_LITTLE_ENDIAN
#else
			endianConverter(&size,sizeof(int)) ;
#endif
			width[fl] = size ;

		}
		if( width[0] != -1 && width[1] != -1 ) {
			if( width[0] != width[1] ) {
				sts = -1 ;
				break ;
			}
		}
		if( fl == 1 && isTGA ) { //At@̓ǂݍ݂͂sf`̂WrbgmNRQrbgt
			if( !(
				(tgah.depth == 8 && tgah.type == DEF_TGA_TYPE_MONO) ||
				(tgah.depth == 32 && tgah.type == DEF_TGA_TYPE_FULL) 
				) ) {
				break ;
			}
		}
		if( fl == 1 && isPNG ) { //At@̓ǂݍ݂͂omf̃gD[J[{At@O[XP[{At@
			if( !(
				(color_type== 6 ) ||
				(color_type== 4 ) 
				) ) {
				break ;
			}
		}

		// ̊m
		if( pImage == NULL ) {
			pImage = (GLubyte*)malloc(sizeof(unsigned char)*size*size*4);
		}
		if (pImage==NULL) return NULL;
		for (y=0; y<size; y++){
			pRead = pImage + (size-1-y)*4*size;
			for (x=0; x<size; x++) {
				other = 1 ;
				if( fl == 0 ) {
					if( isJPEG ) {
#if DEF_USE_LIBJPEG
						pRead[0]= jpegimage[size-1-y][x*3] ;
						pRead[1]= jpegimage[size-1-y][x*3+1] ;
						pRead[2]= jpegimage[size-1-y][x*3+2] ;
						pRead[3] = alpha;				// A
						other = 0 ;
#endif
					}
					if( isPNG ) {
#if DEF_USE_LIBPNG
						if( color_type == 2 || color_type==6 ) { 
							pRead[0]= pngimage[size-1-y][x*pngdepth] ;
							pRead[1]= pngimage[size-1-y][x*pngdepth+1] ;
							pRead[2]= pngimage[size-1-y][x*pngdepth+2] ;
							pRead[3] = alpha;				// A
							if( color_type == 6 ) {
								pRead[3]= pngimage[size-1-y][x*pngdepth+3] ;
							}
						}
						other = 0 ;
#endif
					}
					if( other )  {
						fread(&pRead[2],1,1,fp);	// B
						fread(&pRead[1],1,1,fp);	// G	
						fread(&pRead[0],1,1,fp);	// R
						pRead[3] = alpha;				// A
						if( isTGA && tgah.depth == 32 ) {
							fread(&pRead[3],1,1,fp);	// A
							if( alpha < pRead[3] ) pRead[3] = alpha ;
						}
					}
				}
				else {
					if( isPNG ) {
#if DEF_USE_LIBPNG
						if( color_type == 6 ) { //gD[J[{At@
							pRead[3]= pngimage[size-1-y][x*pngdepth+3] ;
						}
						if( color_type == 4 ) { //O[XP[{At@
							pRead[3]= pngimage[size-1-y][x*pngdepth+1] ;
						}
						if( alpha < pRead[3] ) pRead[3] = alpha ;
#endif
					}
					if( isTGA ) {
						if( tgah.depth == 32 ) { //Ȃf[^ǂݔ΂
							fread(wbuf,3,1,fp);	// BGR
						}
						fread(&pRead[3],1,1,fp);	// A
						if( alpha < pRead[3] ) pRead[3] = alpha ;
					}
				}
				pRead+=4;
			}
		}
		fclose(fp);
		fp = NULL ;
	}
	if( sts != 0 ) {
		if( pImage != NULL ) free(pImage) ;
		if( fp != NULL ) fclose(fp) ;
	}
#if DEF_USE_LIBPNG
	if( pngimage != NULL ) {
		unsigned int uy ;
		for (uy = 0; uy < pngheight; uy++) free(pngimage[uy]);            // ȉQs͂Qz܂
		free(pngimage);
	}
#endif
#if DEF_USE_LIBJPEG
	if( jpegimage != NULL ) {
		unsigned int uy ;
		for (uy = 0; uy < cinfo.output_height; uy++) free(jpegimage[uy]);            // ȉQs͂Qz܂
		free(jpegimage);
	}
#endif
	if( size < 0 ) {
		if( pImage != NULL ) free(pImage) ;
		pImage = NULL ;
	}
	*tex_size = size;

	return pImage;
}

/*=========================================================================
y֐zmqoLoadFile
yprz^ZRCAt@C(*.mqo)烂ff[^OpenGLɓǂݍ
yz
		filename	t@C̃pX
		scale		g嗦

yߒlzF1 ^ sF0
=========================================================================*/
int mqoLoadFile(STR_MQO_OBJECT *mqoobj,char *filename,double scale,unsigned char alpha)
{
	FILE			*fp;
	MQO_OBJECT_V2		obj[N_OBJ];
	MQO_MATERIAL	*M = NULL;

	char	buf[SIZE_STR];
	char	path_dir[SIZE_STR];	// fBNg̃pX
	char	path_tex[SIZE_STR];	// eNX`t@C̃pX
	char path_alp[SIZE_STR];	// At@eNX`t@C̃pX
	int		n_mat = 0;			// }eA
	int		n_obj = 0;			// IuWFNg
	int		i;

	// MaterialObject̓ǂݍ
	fp = fopen(filename,"rb");
	if (fp==NULL) return 0;

	mqoobj->alpha = alpha ;

	memset(obj,0,sizeof(obj)) ;

	i = 0;
	while ( !feof(fp) ) {
		fgets(buf,SIZE_STR,fp);

		// Material
		if (strstr(buf,"Material")) {
			sscanf(buf,"Material %d", &n_mat);
			M = (MQO_MATERIAL*) calloc( n_mat, sizeof(MQO_MATERIAL) );
			mqoReadMaterial(fp,M);
		}

		// Object
		if (strstr(buf,"Object")) {
			sscanf(buf,"Object %s", obj[i].objname);
			mqoReadObject(fp, &obj[i]);
			i++;
		}
	}
	n_obj = i;
	fclose(fp);

	// pX̎擾
	mqoGetDirectory(filename, path_dir);

	// eNX`̓o^
	for (i=0; i<n_mat; i++) {
		if (M[i].useTex) {
			if (strstr(M[i].texFile,":")) {
				strcpy(path_tex, M[i].texFile);	// ΃pX̏ꍇ
			} else {
				sprintf(path_tex,"%s%s",path_dir,M[i].texFile);	// ΃pX̏ꍇ
			}
			if( M[i].alpFile[0] != '\0' ) {
				if (strstr(M[i].texFile,":")) {
					strcpy(path_alp, M[i].alpFile);	// ΃pX̏ꍇ
				} else {
					sprintf(path_alp,"%s%s",path_dir,M[i].alpFile);	// ΃pX̏ꍇ
				}
				M[i].texName = mqoSetTexturePool(path_tex,path_alp,alpha) ;
			}
			else {
				M[i].texName = mqoSetTexturePool(path_tex,NULL,alpha) ;
			}
		}
	}

	mqoMakeObjectsEx(mqoobj,obj,n_obj,M,n_mat,scale,alpha) ;

	// IuWFNg̃f[^̊J
	for (i=0; i<n_obj; i++) {
		free(obj[i].V);
		free(obj[i].F);
	}

	// }eÅJ
	free(M);

	return 1;
}

/*=========================================================================
y֐zmqoCreateList
yprzMQOIuWFNgw萔mۂ
yznum		MQOIuWFNg̐

yߒlzMQOIuWFNg
ydlzMQOIuWFNgiMQO_OBJECTj_zgp͒_̍\̂łB
=========================================================================*/
STR_MQO_OBJECT * mqoCreateList(int num)
{
	STR_MQO_OBJECT * displist;
	if( ! l_GLMetaseqInitialized ) GLMetaseqInitialize() ;//ꉞAĂȂ珉鏈ǉ
	displist = (STR_MQO_OBJECT *)malloc(sizeof(STR_MQO_OBJECT)*num) ;
	memset(displist,0,sizeof(STR_MQO_OBJECT)*num) ;

	return displist;
}
/*=========================================================================
y֐zmqoCreateListObject
yprz^ZRCAt@C(*.mqo)MQOIuWFNg쐬
yzdisplist	MQOIuWFNg
		num			ǂݍݐԍifBXvCXg{numMQOt@Cǂݍށj
		filename	t@C̃pX
		scale		g嗦
		alpha		At@wiŜ̃At@lwiO`QTTjj

yߒlzXe[^X@Fُ@OF
ydlzMQOIuWFNgiMQO_OBJECTj_zgp͒_̍\̂łB
=========================================================================*/
int mqoCreateListObject(STR_MQO_OBJECT * displist,int num,char *filename,double scale,unsigned char alpha)
{
	int ret ;
	ret = 0 ;
	if( displist == (STR_MQO_OBJECT *)NULL ) return -1 ;
	if (! mqoLoadFile(&displist[num],filename,scale,alpha)) ret = -1 ; 
	return ret;
}
/*=========================================================================
y֐zmqoCallObject
yprzMQOIuWFNgOpenGL̉ʏɌĂяo
yz
		object		MQOIuWFNg
		num			Xgԍ

yߒlzȂ
=========================================================================*/
void mqoCallListObject(STR_MQO_OBJECT * object,int num)
{
	int o ;
	int m ;
	char *base ;
	int offset ;
	STR_MQO_INNER_OBJECT *obj ;
	STR_MATERIAL *mat ;
	double dalpha ;
	GLfloat lw[4] ;
	//^ZR͒_̕т\ʂ݂ĉE
	GLint		intFrontFace ;
	GLboolean			isGL_DEPTH_TEST = GL_FALSE ;
	glPushMatrix();
		//^ZR͒_̕т\ʂ݂ĉE
		glGetIntegerv(GL_FRONT_FACE,&intFrontFace) ;
		glFrontFace(GL_CW) ;
		isGL_DEPTH_TEST = glIsEnabled(GL_DEPTH_TEST) ;
		if( isGL_DEPTH_TEST == GL_FALSE ) {
			glEnable(GL_DEPTH_TEST);
		}
//		glRotatef(90.0f, 1.f, 0.f, 0.f); // ARToolKitłZɂȂ̂
		dalpha = (double)object[num].alpha/(double)255 ;
		for( o = 0 ; o < object[num].objnum ; o++ ) {//IuWFNg[v
			obj = &object[num].obj[o] ;
			if( ! obj->isVisible ) continue ;
			for( m = 0 ; m < obj->matnum ; m++ ) {//}eA[v
				mat = &obj->mat[m] ;
				if( mat->datanum == 0 ) continue ;
				if( mat->isValidMaterialInfo ) {//}eȀݒ
					/*
					glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat->dif);
					glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat->amb);
					*/
					memcpy(lw,mat->dif,sizeof(lw)) ;
					lw[3]*=dalpha ;
					glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lw);
					memcpy(lw,mat->amb,sizeof(lw)) ;
					lw[3]*=dalpha ;
					glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lw);
					glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat->spc);
					glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, mat->emi);
					glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat->power);
				}
				if( mat->isUseTexture) {
					glEnableClientState( GL_VERTEX_ARRAY );
					glEnableClientState( GL_NORMAL_ARRAY );
					glEnableClientState( GL_TEXTURE_COORD_ARRAY );

//					glShadeModel(GL_SMOOTH);
					glEnable(GL_TEXTURE_2D);
					glEnable(GL_BLEND);
					glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

					glBindTexture(GL_TEXTURE_2D,mat->texture_id);

					if( g_isVBOSupported ) {//_obt@gp
						base = (char *)NULL ;//AhXNULL擪
						glBindBufferARB( GL_ARRAY_BUFFER_ARB, mat->VBO_id );//_obt@т
					}
					else {
						//_z̎́AAhX̂܂ܓ
						base = (char *)mat->texdata[0].point ;
					}
					//basẽItZbg߂iƂĂA_͂OȂ񂾂ǂˁj
					offset = (int)((char *)mat->texdata[0].point-(char *)mat->texdata[0].point) ;
					//_zݒ@RFOp@GL_FLOATFGLfloat^gp@TCYF_f[^Ԃ̃ItZbg@AhXF擪AhX
					//@@@@@										@ixyzň꒸_Axyz܂ł̃ItZbgj
					glVertexPointer( 3, GL_FLOAT, sizeof(STR_MATERIAL_TEX_USE) , base+offset );
					//basẽItZbg߂iuṽAhX|_̃AhXbase炕܂ł̃ItZbgj
					offset = (int)((char *)mat->texdata[0].uv-(char *)mat->texdata[0].point) ;
					glTexCoordPointer( 2, GL_FLOAT, sizeof(STR_MATERIAL_TEX_USE) , base+offset );
					offset = (int)((char *)mat->texdata[0].normal-(char *)mat->texdata[0].point) ;
					glNormalPointer( GL_FLOAT, sizeof(STR_MATERIAL_TEX_USE) , base+offset );

					glColor4f(mat->mat_color[0],mat->mat_color[1],mat->mat_color[2],mat->mat_color[3]*dalpha) ;

					//`s
					glDrawArrays( GL_TRIANGLES, 0, mat->datanum );

					glDisable(GL_BLEND);
					glDisable(GL_TEXTURE_2D);
					if( g_isVBOSupported ) {//_obt@gp
						glBindBufferARB( GL_ARRAY_BUFFER_ARB, 0 );//_obt@ftHg
					}

					glDisableClientState( GL_VERTEX_ARRAY );
					glDisableClientState( GL_NORMAL_ARRAY );
					glDisableClientState( GL_TEXTURE_COORD_ARRAY );
				}
				else {

					glEnableClientState( GL_VERTEX_ARRAY );
					glEnableClientState( GL_NORMAL_ARRAY );
//					glEnableClientState( GL_COLOR_ARRAY );

					glEnable(GL_BLEND);
					glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

					if( g_isVBOSupported ) {
						base = (char *)NULL ;
						glBindBufferARB( GL_ARRAY_BUFFER_ARB, mat->VBO_id );
					}
					else {
						base = (char *)mat->matdata[0].point ;
					}
					offset = (int)((char *)mat->matdata[0].point-(char *)mat->matdata[0].point) ;
					glVertexPointer( 3, GL_FLOAT, sizeof(STR_MATERIAL_ONLY) , base+offset );
					offset = (int)((char *)mat->matdata[0].normal-(char *)mat->matdata[0].point) ;
					glNormalPointer( GL_FLOAT, sizeof(STR_MATERIAL_ONLY) , base+offset );

					glColor4f(mat->mat_color[0],mat->mat_color[1],mat->mat_color[2],mat->mat_color[3]*dalpha) ;
//					offset = (int)((char *)mat->matdata[0].color-(char *)mat->matdata[0].point) ;
//					glColorPointer(4,GL_FLOAT,sizeof(STR_MATERIAL_ONLY),base+offset) ;

					glDrawArrays( GL_TRIANGLES, 0, mat->datanum );

					glDisable(GL_BLEND);
					if( g_isVBOSupported ) {//_obt@gp
						glBindBufferARB( GL_ARRAY_BUFFER_ARB, 0 );//_obt@ftHg
					}

//					glDisableClientState( GL_COLOR_ARRAY );
					glDisableClientState( GL_VERTEX_ARRAY );
					glDisableClientState( GL_NORMAL_ARRAY );

				}
			}
		}
		//^ZR͒_̕т\ʂ݂ĉEi̐ݒɂǂj
		glFrontFace(intFrontFace) ;

		if( isGL_DEPTH_TEST == GL_FALSE ) {
			glDisable(GL_DEPTH_TEST);
		}
	glPopMatrix();
}
//MQO_OBJECT̃NA
void mqoClearObject(STR_MQO_OBJECT * object,int from,int num) 
{
{
	int loop ;
	int o ;
	int m ;
	STR_MQO_INNER_OBJECT *obj ;
	STR_MATERIAL *mat ;
	if( object == NULL ) return ;
	for( loop = from ; loop < from +num ; loop++ ) {
		for( o = 0 ; o < (object+from)->objnum ; o++ ) {
			obj = &(object+loop)->obj[o] ;
			for( m = 0 ; m < obj->matnum ; m++ ) {
				mat = &obj->mat[m] ;
				if( mat->datanum <= 0 ) continue ;
				if( g_isVBOSupported ) {
					//_obt@̍폜
					glDeleteBuffersARB( 1, &mat->VBO_id );
				}
				//_z̍폜
				if( mat->isUseTexture ) {
					if( mat->texdata != NULL ) free(mat->texdata) ;
				}
				else {
					if( mat->matdata != NULL ) free(mat->matdata) ;
				}
			}
			free(obj->mat) ;
			obj->matnum = 0 ;
		}
	}
}
}
//MQO_MODEL̍폜
// MQO_MODEL object	:폜MQO_MODEL
// int num				:폜
void mqoDeleteObject(STR_MQO_OBJECT * object,int num)
{
	mqoClearObject(object,0,num) ;
	free(object) ;
}

//MQO_MODEL̓Ƀf[^ݒ肷
void mqoSet(E_MQO mode,STR_MQO_OBJECT * object,...) 
{
	va_list args ;

	va_start(args,object) ;
	switch(mode) {
	case E_MQO_VISIBLE :
		//@ϕF	int IuWFNgz̈ʒu
		//				int OF\^̑F\
		{
			int objpos ;
			int  isVisible ;
			objpos = (int)va_arg(args,int) ;
			isVisible = (int)va_arg(args,int) ;
			object->obj[objpos].isVisible = isVisible ;
		}
		break ;
	case E_MQO_ALPHA :
		//@ϕF		unsigned char * At@liO`QTTj
		{
			unsigned char *uc ;
			uc = (unsigned char *)va_arg(args,unsigned char *) ;
			object->alpha = *uc ;
		}
		break ;
	default :
		printf("mqoSet : `̏[%d]\n",mode) ;
		break ;
	}

	va_end(args) ;
}
//MQO_OBJECT̓f[^o
void mqoGet(E_MQO mode,STR_MQO_OBJECT * object,...) 
{
	va_list args ;

	va_start(args,object) ;
	switch(mode) {
	case E_MQO_VISIBLE :
		//@ϕFin		int IuWFNgz̈ʒu
		//			out		char * IuWFNg
		//			out		int  * OF\^̑F\
		{
			int pos ;
			char *name ;
			int  *isVisible ;
			pos =  (int)va_arg(args,int) ;
			if( object->objnum <= pos ) {
				break ;
			}
			name = (char *)va_arg(args,char *) ;
			isVisible = (int *)va_arg(args,int *) ;
			strcpy(name,object->obj[pos].objname) ;
			*isVisible = object->obj[pos].isVisible ;
		}
		break ;
	case E_MQO_ALPHA :
		//@ϕFout		unsigned char * At@liO`QTTj
		{
			unsigned char *uc ;
			uc = (unsigned char *)va_arg(args,unsigned char *) ;
			*uc = object->alpha ;
		}
		break ;
	default :
		printf("mqoGet : `̏[%d]\n",mode) ;
		break ;
	}

	va_end(args) ;
}

////////////////////////////////////////////////////////////////////////////////////////////
// ֐{


/*=========================================================================
y֐zmqoGetDirectory
yprzt@C܂ރpX񂩂fBNg̃pX݂̂𒊏o
yz
		*path_file	t@C܂ރpXíj
		*path_dir	t@CpXiój

yߒlzȂ
ydlzF
		"C:/data/file.bmp"  "C:/data/"
		"data/file.mqo"     "data/"
=========================================================================*/

void mqoGetDirectory(const char *path_file, char *path_dir)
{
	char *pStr;
	int len;

	pStr = MAX( strrchr(path_file,'\\'), strrchr(path_file,'/') );
	len = MAX((int)(pStr-path_file)+1,0);
	strncpy(path_dir,path_file,len);
	path_dir[len] = '\0';
}






/*=========================================================================
y֐zmqoSnormal
yprz@xNg߂
yz
		A		3W̓_A
		B		3W̓_B
		C		3W̓_C
		*normal	xNgBAƃxNgBC̖@xNgiE˂j

yߒlzȂ
ydlz^ZRCAɂĖʂ\钸_̔ԍ́C\ʂ猩
		vɋLqĂD܂C_A,B,C ƂC
		߂ׂ@BABC̊Oςɂċ߂
=========================================================================*/

void mqoSnormal(glPOINT3f A, glPOINT3f B, glPOINT3f C, glPOINT3f *normal)
{
	double norm;
	glPOINT3f vec0,vec1;

	// xNgBA
	vec0.x = A.x - B.x; 
	vec0.y = A.y - B.y;
	vec0.z = A.z - B.z;

	// xNgBC
	vec1.x = C.x - B.x;
	vec1.y = C.y - B.y;
	vec1.z = C.z - B.z;

	// @xNg
	normal->x = vec0.y * vec1.z - vec0.z * vec1.y;
	normal->y = vec0.z * vec1.x - vec0.x * vec1.z;
	normal->z = vec0.x * vec1.y - vec0.y * vec1.x;

	// K
	norm = normal->x * normal->x + normal->y * normal->y + normal->z * normal->z;
	norm = sqrt ( norm );

	normal->x /= norm;
	normal->y /= norm;
	normal->z /= norm;
}



/*=========================================================================
y֐zmqoReadMaterial
yprz}eA̓ǂݍ
yz
		fp		t@C|C^
		M		}eAz

yߒlzȂ
ydlzmqoCreateModel(), mqoCreateSequence()̃Tu֐D
=========================================================================*/

void mqoReadMaterial(FILE *fp, MQO_MATERIAL M[])
{
	GLfloat		dif, amb, emi, spc;
	glCOLOR4f	c;
	char		buf[SIZE_STR];
	char		*pStrEnd, *pStr;
	int			len;
	int			i = 0;

	while (1) {
		fgets(buf,SIZE_STR,fp);	// sǂݍ
		if (strstr(buf,"}")) break;

		pStr = strstr(buf,"col(");	// ގǂݔ΂
		sscanf( pStr,
				"col(%f %f %f %f) dif(%f) amb(%f) emi(%f) spc(%f) power(%f)",
				&c.r, &c.g, &c.b, &c.a, &dif, &amb, &emi, &spc, &M[i].power );

		// _J[
		M[i].col = c;

		// gU
		M[i].dif[0] = dif * c.r;
		M[i].dif[1] = dif * c.g;
		M[i].dif[2] = dif * c.b;
		M[i].dif[3] = c.a;

		// ͌
		M[i].amb[0] = amb * c.r;
		M[i].amb[1] = amb * c.g;
		M[i].amb[2] = amb * c.b;
		M[i].amb[3] = amb * c.a;

		// ȏƖ
		M[i].emi[0] = emi * c.r;
		M[i].emi[1] = emi * c.g;
		M[i].emi[2] = emi * c.b;
		M[i].emi[3] = emi * c.a;

		// ˌ
		M[i].spc[0] = spc * c.r;
		M[i].spc[1] = spc * c.g;
		M[i].spc[2] = spc * c.b;
		M[i].spc[3] = spc * c.a;

		
		// texF͗l}bsO
		if ( (pStr = strstr(buf,"tex(")) != NULL ) {
			M[i].useTex = TRUE;

			pStrEnd = strstr(pStr,"\")");
			len = pStrEnd - (pStr+5);
			strncpy(M[i].texFile,pStr+5,len);
			M[i].texFile[len] = '\0';
			if ( (pStr = strstr(buf,"aplane(")) != NULL ) {
				pStrEnd = strstr(pStr,"\")");
				len = pStrEnd - (pStr+8);
				strncpy(M[i].alpFile,pStr+8,len);
				M[i].alpFile[len] = '\0';
			}
			else {
				M[i].alpFile[0] = '\0' ;
			}

		} else {
			M[i].useTex = FALSE;
			M[i].texFile[0] = '\0';
			M[i].alpFile[0] = '\0' ;
		}

		i++;
	}

}



/*=========================================================================
y֐zmqoReadVertex
yprz_̓ǂݍ
yz
		fp		t@C|C^
		V		_z
		
yߒlzȂ
ydlzmqoReadObject()̃Tu֐D
=========================================================================*/

void mqoReadVertex(FILE *fp, glPOINT3f V[])
{
	char buf[SIZE_STR];
	int  i=0;

	while (1) {
		fgets(buf,SIZE_STR,fp);
		if (strstr(buf,"}")) break;
		sscanf(buf,"%f %f %f",&V[i].x,&V[i].y,&V[i].z);
		i++;
	}
}
/*=========================================================================
y֐zmqoReadBVertex
yprz^ZRCAt@CoCi`̒_ǂݍ

yz*fp			݃I[vĂ郁^ZRCAt@C̃t@C|C^
		V[]			_i[z
		max_vertex	_̏

yߒlz_
ydlzmqoLoadFile̎q֐Ȃ̂łP̂ŎgƂ͂Ȃ
=========================================================================*/

int mqoReadBVertex(FILE *fp,glPOINT3f V[])
{
	int n_vertex,i;
	float *wf ;
	int size ;
	char cw[256] ;
	char *pStr ;

	fgets(cw,sizeof(cw),fp) ;
	if ( (pStr = strstr(cw,"Vector")) != NULL ) {
		sscanf(pStr,"Vector %d [%d]",&n_vertex,&size);				// _Af[^TCYǂݍ
	}
	else {
		return -1 ;
	}
	//MQOt@C̃oCi_f[^intel`igGfBAj
	wf = (float *)malloc(size) ;
	fread(wf,size,1,fp) ;
	for( i = 0 ; i < n_vertex ; i++ ) {
		V[i].x = wf[i*3+0] ;
		V[i].y = wf[i*3+1] ;
		V[i].z = wf[i*3+2] ;
#if DEF_IS_LITTLE_ENDIAN
#else
		endianConverter((void *)&V[i].x,sizeof(V[i].x)) ;
		endianConverter(&V[i].y,sizeof(V[i].y)) ;
		endianConverter(&V[i].z,sizeof(V[i].z)) ;
#endif
	}
	free(wf) ;

	// "}"܂œǂݔ΂
	{
		char buf[SIZE_STR] ;
		while (1) {
			fgets(buf,SIZE_STR,fp);
			if (strstr(buf,"}")) break;
		}
	}

	return n_vertex;
}



/*=========================================================================
y֐zmqoReadFace
yprzʏ̓ǂݍ
yz
		fp		t@C|C^
		F		ʔz
		
yߒlzȂ
ydlzmqoReadObject()̃Tu֐D
=========================================================================*/

void mqoReadFace(FILE *fp, MQO_FACE F[])
{
	char buf[SIZE_STR];
	char *pStr;
	int  i=0;

	while (1) {
		fgets(buf,SIZE_STR,fp);
		if (strstr(buf,"}")) break;

		// ʂ\钸_
		sscanf(buf,"%d",&F[i].n);

		// _(V)̓ǂݍ
		if ( (pStr = strstr(buf,"V(")) != NULL ) {
			switch (F[i].n) {
				case 3:
					sscanf(pStr,"V(%d %d %d)",&F[i].v[0],&F[i].v[1],&F[i].v[2]);
					break;
				case 4:
					sscanf(pStr,"V(%d %d %d %d)",&F[i].v[0],&F[i].v[1],&F[i].v[2],&F[i].v[3]);
					break;
				default:
					break;
			}		
		}

		// }eA(M)̓ǂݍ
		F[i].m = 0;
		if ( (pStr = strstr(buf,"M(")) != NULL ) {
			sscanf(pStr,"M(%d)",&F[i].m);
		}

		// UV}bv(UV)̓ǂݍ
		if ( (pStr = strstr(buf,"UV(")) != NULL ) {
			switch (F[i].n) {
				case 3:	// _3
					sscanf(pStr,"UV(%f %f %f %f %f %f)",
									&F[i].uv[0].x, &F[i].uv[0].y,
									&F[i].uv[1].x, &F[i].uv[1].y,
									&F[i].uv[2].x, &F[i].uv[2].y
									);
					break;

				case 4:	// _4
					sscanf(pStr,"UV(%f %f %f %f %f %f %f %f)",
									&F[i].uv[0].x, &F[i].uv[0].y,
									&F[i].uv[1].x, &F[i].uv[1].y,
									&F[i].uv[2].x, &F[i].uv[2].y,
									&F[i].uv[3].x, &F[i].uv[3].y
									);
					break;
				default:
					break;
			}		
		}

		i++;
	}

}



/*=========================================================================
y֐zmqoReadObject
yprzIuWFNg̓ǂݍ
yz
		fp		t@C|C^
		obj		IuWFNg

yߒlzȂ
ydlzmqoCreateModel(), mqoCreateSequence()̃Tu֐D
		̊֐łP̃IuWFNg񂪓ǂݍ܂D
=========================================================================*/

void mqoReadObject(FILE *fp, MQO_OBJECT_V2 *obj)
{
	char buf[SIZE_STR];

	while (1) {
		fgets(buf,SIZE_STR,fp);
		if (strstr(buf,"}")) break;

		// visible
		if (strstr(buf,"visible ")) {
			sscanf(buf," visible %d", &obj->visible);
		}

		// facet
		if (strstr(buf,"facet ")) {
			sscanf(buf," facet %f", &obj->facet);
		}

		// vertex
		if (strstr(buf,"vertex ")) {
			sscanf(buf," vertex %d", &obj->n_vertex);
			obj->V = (glPOINT3f*) calloc( obj->n_vertex, sizeof(glPOINT3f) );
			mqoReadVertex(fp, obj->V);
		}
		// BVertex
		if (strstr(buf,"BVertex"))	{
			sscanf(buf," BVertex %d", &obj->n_vertex);
			obj->V = (glPOINT3f*) calloc( obj->n_vertex, sizeof(glPOINT3f) );
			mqoReadBVertex(fp,obj->V);
		}

		// face
		if (strstr(buf,"face ")) {
			sscanf(buf," face %d", &obj->n_face);
			obj->F = (MQO_FACE*) calloc( obj->n_face, sizeof(MQO_FACE) );
			mqoReadFace(fp, obj->F);
		}

	}

}



/*=========================================================================
y֐zmqoMakePolygon
yprz|S̍쐬
yz
		*F		ʏ
		V[]		_z
		M[]		}eAz
yߒlzȂ
ydlzmqoMakeObjects()̃Tu֐D
		̊֐łP̃|SD
=========================================================================*/

//_z̍쐬
//_zׂ͂ĎOpɂ̂ŁAlp͎OpQɕ
//  0  3      0    0  3
//      @@@
//  1  2     1  2   2
void mqoMakeArray(STR_MATERIAL *mat,int matpos,MQO_FACE F[],int fnum,glPOINT3f V[],glPOINT3f N[],double facet,glCOLOR4f *mcol,double scale,unsigned char alpha)
{
	int f ;
	int i ;
	int dpos ;
	double s ;
	glPOINT3f normal;	// @xNg
	
	dpos = 0 ;
	mat->mat_color[0] = mcol->r ;
	mat->mat_color[1] = mcol->g ;
	mat->mat_color[2] = mcol->b ;
	mat->mat_color[3] = mcol->a ;
	if( mat->isUseTexture ) {
		for( f = 0 ; f < fnum ; f++ ){
			if( F[f].m != matpos ) continue ;
			if( F[f].n == 3 ) {
				mqoSnormal(V[F[f].v[0]],V[F[f].v[1]],V[F[f].v[2]],&normal);	// @xNgvZ
				for( i = 0 ; i < 3 ; i++ ) {
					mat->texdata[dpos].point[0] = V[F[f].v[i]].x*scale ;
					mat->texdata[dpos].point[1] = V[F[f].v[i]].y*scale ;
					mat->texdata[dpos].point[2] = V[F[f].v[i]].z*scale ;
					mat->texdata[dpos].uv[0] = F[f].uv[i].x ;
					mat->texdata[dpos].uv[1] = F[f].uv[i].y ;
					s = acos(normal.x*N[F[f].v[i]].x + normal.y*N[F[f].v[i]].y + normal.z*N[F[f].v[i]].z) ;
					if( facet < s ) {
						mat->texdata[dpos].normal[0] = normal.x ;
						mat->texdata[dpos].normal[1] = normal.y ;
						mat->texdata[dpos].normal[2] = normal.z ;
					}
					else {
						mat->texdata[dpos].normal[0] = N[F[f].v[i]].x ;
						mat->texdata[dpos].normal[1] = N[F[f].v[i]].y ;
						mat->texdata[dpos].normal[2] = N[F[f].v[i]].z ;
					}
					dpos++ ;
				}
			}
			//S_ilpj͂R_iOpjQɕ
			if( F[f].n == 4 ) {
				mqoSnormal(V[F[f].v[0]],V[F[f].v[1]],V[F[f].v[2]],&normal);	// @xNgvZ
				for( i = 0 ; i < 4 ; i++ ) {
					if( i == 3 ) continue ;
					mat->texdata[dpos].point[0] = V[F[f].v[i]].x*scale ;
					mat->texdata[dpos].point[1] = V[F[f].v[i]].y*scale ;
					mat->texdata[dpos].point[2] = V[F[f].v[i]].z*scale ;
					mat->texdata[dpos].uv[0] = F[f].uv[i].x ;
					mat->texdata[dpos].uv[1] = F[f].uv[i].y ;
					s = acos(normal.x*N[F[f].v[i]].x + normal.y*N[F[f].v[i]].y + normal.z*N[F[f].v[i]].z) ;
					if( facet < s ) {
						mat->texdata[dpos].normal[0] = normal.x ;
						mat->texdata[dpos].normal[1] = normal.y ;
						mat->texdata[dpos].normal[2] = normal.z ;
					}
					else {
						mat->texdata[dpos].normal[0] = N[F[f].v[i]].x ;
						mat->texdata[dpos].normal[1] = N[F[f].v[i]].y ;
						mat->texdata[dpos].normal[2] = N[F[f].v[i]].z ;
					}
					dpos++ ;
				}
				mqoSnormal(V[F[f].v[0]],V[F[f].v[2]],V[F[f].v[3]],&normal);	// @xNgvZ
				for( i = 0 ; i < 4 ; i++ ) {
					if( i == 1 ) continue ;
					mat->texdata[dpos].point[0] = V[F[f].v[i]].x*scale ;
					mat->texdata[dpos].point[1] = V[F[f].v[i]].y*scale ;
					mat->texdata[dpos].point[2] = V[F[f].v[i]].z*scale ;
					mat->texdata[dpos].uv[0] = F[f].uv[i].x ;
					mat->texdata[dpos].uv[1] = F[f].uv[i].y ;
					s = acos(normal.x*N[F[f].v[i]].x + normal.y*N[F[f].v[i]].y + normal.z*N[F[f].v[i]].z) ;
					if( facet < s ) {
						mat->texdata[dpos].normal[0] = normal.x ;
						mat->texdata[dpos].normal[1] = normal.y ;
						mat->texdata[dpos].normal[2] = normal.z ;
					}
					else {
						mat->texdata[dpos].normal[0] = N[F[f].v[i]].x ;
						mat->texdata[dpos].normal[1] = N[F[f].v[i]].y ;
						mat->texdata[dpos].normal[2] = N[F[f].v[i]].z ;
					}
					dpos++ ;
				}
			}
		}
	}
	else {
		if( alpha != 255 ) {
			mat->mat_color[3] = (double)alpha/(double)255 ;
		}
		for( f = 0 ; f < fnum ; f++ ){
			if( F[f].m != matpos ) continue ;
			if( F[f].n == 3 ) {
				mqoSnormal(V[F[f].v[0]],V[F[f].v[1]],V[F[f].v[2]],&normal);					// @xNgvZ
				for( i = 0 ; i < 3 ; i++ ) {
					mat->matdata[dpos].point[0] = V[F[f].v[i]].x*scale ;
					mat->matdata[dpos].point[1] = V[F[f].v[i]].y*scale ;
					mat->matdata[dpos].point[2] = V[F[f].v[i]].z*scale ;
					mat->matdata[dpos].normal[0] = normal.x;
					mat->matdata[dpos].normal[1] = normal.y;
					mat->matdata[dpos].normal[2] = normal.z;
					s = acos(normal.x*N[F[f].v[i]].x + normal.y*N[F[f].v[i]].y + normal.z*N[F[f].v[i]].z) ;
					if( facet < s ) {
						mat->matdata[dpos].normal[0] = normal.x ;
						mat->matdata[dpos].normal[1] = normal.y ;
						mat->matdata[dpos].normal[2] = normal.z ;
					}
					else {
						mat->matdata[dpos].normal[0] = N[F[f].v[i]].x ;
						mat->matdata[dpos].normal[1] = N[F[f].v[i]].y ;
						mat->matdata[dpos].normal[2] = N[F[f].v[i]].z ;
					}
					dpos++ ;
				}
			}
			//S_ilpj͂R_iOpjQɕ
			if( F[f].n == 4 ) {
				mqoSnormal(V[F[f].v[0]],V[F[f].v[1]],V[F[f].v[2]],&normal);					// @xNgvZ
				for( i = 0 ; i < 4 ; i++ ) {
					if( i == 3 ) continue ;
					mat->matdata[dpos].point[0] = V[F[f].v[i]].x*scale ;
					mat->matdata[dpos].point[1] = V[F[f].v[i]].y*scale ;
					mat->matdata[dpos].point[2] = V[F[f].v[i]].z*scale ;
					mat->matdata[dpos].normal[0] = normal.x;
					mat->matdata[dpos].normal[1] = normal.y;
					mat->matdata[dpos].normal[2] = normal.z;
					s = acos(normal.x*N[F[f].v[i]].x + normal.y*N[F[f].v[i]].y + normal.z*N[F[f].v[i]].z) ;
					if( facet < s ) {
						mat->matdata[dpos].normal[0] = normal.x ;
						mat->matdata[dpos].normal[1] = normal.y ;
						mat->matdata[dpos].normal[2] = normal.z ;
					}
					else {
						mat->matdata[dpos].normal[0] = N[F[f].v[i]].x ;
						mat->matdata[dpos].normal[1] = N[F[f].v[i]].y ;
						mat->matdata[dpos].normal[2] = N[F[f].v[i]].z ;
					}
					dpos++ ;
				}
				mqoSnormal(V[F[f].v[0]],V[F[f].v[2]],V[F[f].v[3]],&normal);					// @xNgvZ
				for( i = 0 ; i < 4 ; i++ ) {
					if( i == 1 ) continue ;
					mat->matdata[dpos].point[0] = V[F[f].v[i]].x*scale ;
					mat->matdata[dpos].point[1] = V[F[f].v[i]].y*scale ;
					mat->matdata[dpos].point[2] = V[F[f].v[i]].z*scale ;
					mat->matdata[dpos].normal[0] = normal.x;
					mat->matdata[dpos].normal[1] = normal.y;
					mat->matdata[dpos].normal[2] = normal.z;
					s = acos(normal.x*N[F[f].v[i]].x + normal.y*N[F[f].v[i]].y + normal.z*N[F[f].v[i]].z) ;
					if( facet < s ) {
						mat->matdata[dpos].normal[0] = normal.x ;
						mat->matdata[dpos].normal[1] = normal.y ;
						mat->matdata[dpos].normal[2] = normal.z ;
					}
					else {
						mat->matdata[dpos].normal[0] = N[F[f].v[i]].x ;
						mat->matdata[dpos].normal[1] = N[F[f].v[i]].y ;
						mat->matdata[dpos].normal[2] = N[F[f].v[i]].z ;
					}
					dpos++ ;
				}
			}
		}
	}
}
//_@̌vZiS_̖ʂ́ɕČvZj
//^[l͌Ăяofree邱ƁI
glPOINT3f *mqoVertexNormal(MQO_OBJECT_V2 *obj) {
	int f ;
	int v ;
	int i ;
	double len ;
	glPOINT3f fnormal;	// ʖ@xNg
	MQO_FACE *F ;
	glPOINT3f *V ;
	glPOINT3f *ret ;
	F = obj->F ;
	V = obj->V ;
	ret = (glPOINT3f *)calloc(obj->n_vertex,sizeof(glPOINT3f)) ;
	//ʂ̖@𒸓_ɑ
	for( f = 0 ; f < obj->n_face ; f++ ) {
		if( obj->F[f].n == 3 ) {
			mqoSnormal(V[F[f].v[0]],V[F[f].v[1]],V[F[f].v[2]],&fnormal);
			for( i = 0 ; i < 3 ; i++ ) {
				ret[F[f].v[i]].x += fnormal.x ;
				ret[F[f].v[i]].y += fnormal.y ;
				ret[F[f].v[i]].z += fnormal.z ;
			}
		}
		if( obj->F[f].n == 4 ) {
			mqoSnormal(V[F[f].v[0]],V[F[f].v[1]],V[F[f].v[2]],&fnormal);
			for( i = 0 ; i < 4 ; i++ ) {
				if( i == 3 ) continue ;
				ret[F[f].v[i]].x += fnormal.x ;
				ret[F[f].v[i]].y += fnormal.y ;
				ret[F[f].v[i]].z += fnormal.z ;
			}
			mqoSnormal(V[F[f].v[0]],V[F[f].v[2]],V[F[f].v[3]],&fnormal);
			for( i = 0 ; i < 4 ; i++ ) {
				if( i == 1 ) continue ;
				ret[F[f].v[i]].x += fnormal.x ;
				ret[F[f].v[i]].y += fnormal.y ;
				ret[F[f].v[i]].z += fnormal.z ;
			}
		}
	}
	//K
	for( v = 0 ; v < obj->n_vertex ; v++ ) {
		if( ret[v].x == 0 && ret[v].y == 0 && ret[v].z == 0 ) {
			//ʂɎgĂȂ_
			continue ;
		}
		len = sqrt(ret[v].x*ret[v].x + ret[v].y*ret[v].y + ret[v].z*ret[v].z) ;
		if( len != 0 ) {
			ret[v].x = ret[v].x/len ;
			ret[v].y = ret[v].y/len ;
			ret[v].z = ret[v].z/len ;
		}
	}

	return ret ;
}
//}eAɒ_z쐬
void mqoMakePolygonEx(char *objname,int isVisible,STR_MQO_OBJECT * mqoobj,
					  MQO_FACE F[],int fnum,glPOINT3f V[],glPOINT3f N[],MQO_MATERIAL M[],
					  int n_mat,double facet,double scale,unsigned char alpha)
{
	int f ;
	int m ;
	int *mat_vnum ;
	STR_MQO_INNER_OBJECT *setObj ;
	STR_MATERIAL *material ;
	glCOLOR4f defcol ;
	glCOLOR4f *pcol ;

	setObj = &mqoobj->obj[mqoobj->objnum] ;
	strcpy(setObj->objname,objname) ;
	setObj->isVisible = isVisible ;

	//face̒ł̃}eA̒_̐
	// M=NULL̂ƂAF[].m = 0 Ă
	if( M == NULL ) n_mat = 1 ;

	mat_vnum = (int *)malloc(sizeof(int)*n_mat) ;
	memset(mat_vnum,0,sizeof(int)*n_mat) ;
	for( f = 0 ; f < fnum ; f++ ){
		if( F[f].n == 3 ) {
			mat_vnum[F[f].m] += 3 ;
		}
		if( F[f].n == 4 ) {
			//S_ilpj͂R_iOpjQɕ
			//  0  3      0    0  3
			//      @@@
			//  1  2     1  2   2
			// S_̕ʃf[^
			// R_̕ʃf[^Q
			mat_vnum[F[f].m] += 3*2 ;
		}
		if( setObj->matnum < F[f].m+1 ) setObj->matnum = F[f].m+1 ;
	}
	//}eAʂɒ_z쐬
	setObj->mat = (STR_MATERIAL *)malloc(sizeof(STR_MATERIAL)*setObj->matnum) ;
	memset(setObj->mat,0,sizeof(STR_MATERIAL)*setObj->matnum) ;
	for( m = 0 ; m < setObj->matnum ; m++ ) {
		material = &setObj->mat[m] ;
		material->datanum = mat_vnum[m] ;
		material->isValidMaterialInfo = (M != NULL) ;
		if( mat_vnum[m] <= 0 ) continue ;
		if( material->isValidMaterialInfo ) {
			memcpy(material->dif,M[m].dif,sizeof(material->dif)) ;
			memcpy(material->amb,M[m].amb,sizeof(material->amb)) ;
			memcpy(material->spc,M[m].spc,sizeof(material->spc)) ;
			memcpy(material->emi,M[m].emi,sizeof(material->emi)) ;
			material->power = M[m].power ;
			material->isUseTexture = M[m].useTex ;
			pcol = &M[m].col ;
		}
		else {
			defcol.r = 1.0 ;
			defcol.g = 1.0 ;
			defcol.b = 1.0 ;
			defcol.a = 1.0 ;
			material->isUseTexture = 0 ;
			pcol = &defcol ;
		}
		if( material->isUseTexture ) {
			material->texdata = (STR_MATERIAL_TEX_USE *)calloc(material->datanum,sizeof(STR_MATERIAL_TEX_USE)) ;
			material->texture_id = M[m].texName ;
		}
		else {
			material->matdata = (STR_MATERIAL_ONLY *)calloc(material->datanum,sizeof(STR_MATERIAL_ONLY)) ;
		}
		mqoMakeArray(material,m,F,fnum,V,N,facet,pcol,scale,alpha) ;
		if(g_isVBOSupported) {
			if( material->isUseTexture ) {
				glGenBuffersARB( 1, &material->VBO_id );
				glBindBufferARB( GL_ARRAY_BUFFER_ARB, material->VBO_id  );
				glBufferDataARB( GL_ARRAY_BUFFER_ARB, material->datanum*sizeof(STR_MATERIAL_TEX_USE), material->texdata, GL_STATIC_DRAW_ARB );
			}
			else {
				glGenBuffersARB( 1, &material->VBO_id );
				glBindBufferARB( GL_ARRAY_BUFFER_ARB, material->VBO_id  );
				glBufferDataARB( GL_ARRAY_BUFFER_ARB, material->datanum*sizeof(STR_MATERIAL_ONLY), material->matdata, GL_STATIC_DRAW_ARB );
			}
		}
	}
	mqoobj->objnum++ ;
	if( MAX_OBJECT <= mqoobj->objnum ) {
		printf("MQOt@Cǂݍ݁F@őIuWFNg𒴂܂[%d]\n",mqoobj->objnum) ;
		mqoobj->objnum = MAX_OBJECT-1 ;
	}

	free(mat_vnum) ;

}


/*=========================================================================
y֐zmqoMakeObjects
yprzIuWFNg̃f[^|Sf쐬
yz
		obj		IuWFNgz
		n_obj	IuWFNǧ
		M		}eAz

yߒlzȂ
ydlzmqoCreateModel(), mqoCreateSequence()̃Tu֐D
		IuWFNgC}eAɃ|Sf쐬D
=========================================================================*/
void mqoMakeObjectsEx(STR_MQO_OBJECT *mqoobj,MQO_OBJECT_V2 obj[], int n_obj, MQO_MATERIAL M[],int n_mat,
					  double scale,unsigned int alpha)
{
	int i;
	glPOINT3f *N ;
	for (i=0; i<n_obj; i++) {
		N = mqoVertexNormal(&obj[i]) ;
			mqoMakePolygonEx(
				obj[i].objname,
				obj[i].visible,mqoobj,
				obj[i].F,
				obj[i].n_face, 
				obj[i].V, 
				N,
				M,n_mat,
				obj[i].facet,
				scale,
				alpha) ;
		free(N) ;
	}
}


/*=========================================================================
y֐zmqoCreateModel
yprzMQOt@CMQOf쐬
yz
		filename	MQOt@C
		scale		g嗦i1.0ł̂܂܁j

yߒlzMQO_MODELiMQOfj
=========================================================================*/

MQO_MODEL mqoCreateModel(char *filename, double scale)
{
	MQO_MODEL ret ;
	ret = mqoCreateList(1) ;
	if( mqoCreateListObject(ret,1-1,filename,scale,(unsigned char)255) < 0 ) {
		mqoDeleteObject(ret,1) ;
		ret = NULL ;
	}
	return ret ;
}

/*=========================================================================
y֐zmqoCreateSequence
yprzAԂMQOt@CMQOV[PX쐬
yz
		basename	t@CAԐ".mqo"x[Xt@C
		n_file		t@C
		scale		g嗦i1.0ł̂܂܁j
		fade_inout	0:̂܂܁@FtF[hC@FtF[hAEg
					Βl͌ʂɂt[

yߒlzMQO_SEQUENCEiMQOV[PXj
ydlzdata0.mqo, data1.mqo, ... Ƃ̘AԂMQOt@Cǂݍ
		MQOV[PX쐬D}eA1Ԗڂ̃t@Ĉ
		ǂݍށD
=========================================================================*/
MQO_SEQUENCE mqoCreateSequenceEx(const char *basename, const char *format,int n_file,
								 double scale,int fade_inout,unsigned char alpha)
{
	MQO_SEQUENCE retSeq ;
	int iret ;
	int seq ;
	char filename[SIZE_STR] ;
	short setAlpha ;
	short calAlpha ;
	int frames ;

	retSeq.n_frame = 0 ;
	if( basename == NULL ) {
		return retSeq ;
	}
	calAlpha = alpha ;
	frames = abs(fade_inout) ;
	frames = MAX(frames,n_file) ;
	setAlpha = (fade_inout<=0)?alpha:0 ;



	retSeq.model = mqoCreateList(n_file) ;
	for( seq = 0 ; seq < frames ; seq++ ) {
		if( seq < n_file ) {
			if( format == NULL ) {
				sprintf(filename,"%s",basename) ;
			}
			else {
				sprintf(filename,format,basename,seq) ;
			}
		}
		if( (fade_inout !=  0) && ((frames-1) == seq) ) {
			setAlpha = (fade_inout<0)?0:calAlpha ;
		}
		iret = mqoCreateListObject(retSeq.model,seq,filename,scale,(unsigned char)setAlpha) ;
		if( iret == - 1 ) {
			seq-- ;
			mqoClearObject(retSeq.model,seq,n_file-seq) ;
			break ;
		}
		if( fade_inout !=  0 ) {
			if( fade_inout<0 ) {
				if( (n_file-seq) <= (-1*fade_inout) ) {
					setAlpha -= (calAlpha/(-1*fade_inout)) ;
					if( setAlpha < 0 ) setAlpha = 0 ;
				}
			}
			else {
				setAlpha += (calAlpha/fade_inout) ;
				if( calAlpha < setAlpha ) setAlpha = calAlpha ;
			}
		}
	}
	retSeq.n_frame = seq ;
	return retSeq ;
}
MQO_SEQUENCE mqoCreateSequence(char *basename, int n_file, double scale)
{
	return mqoCreateSequenceEx(basename,DEF_DEFAULT_FORMAT,n_file,scale,0,(unsigned char)255) ;
}



/*=========================================================================
y֐zmqoCallModel
yprzMQOfOpenGL̉ʏɌĂяo
yz
		model		MQOf

yߒlzȂ
=========================================================================*/

void mqoCallModel(MQO_MODEL model)
{
	mqoCallListObject(model,0) ;
}



/*=========================================================================
y֐zmqoCallSequence
yprzMQOV[PXOpenGL̉ʂɌĂяo
yz
		seq		MQOV[PX
		i		t[ԍ

yߒlzȂ
ydlzMQOV[PX̒w肵t[ԍ̃fĂяoD
=========================================================================*/

void mqoCallSequence(MQO_SEQUENCE seq, int i)
{
	if ( i>=0 && i<seq.n_frame ) {
		mqoCallListObject(seq.model,i) ;
	}
}



/*=========================================================================
y֐zmqoDeleteModel
yprzMQOf폜
yz
		model	MQOf

yߒlzȂ
ydlzƂĂ̓fBXvCXg̍폜Ɠ`D
=========================================================================*/
void mqoDeleteModel(MQO_MODEL model)
{
	mqoDeleteObject(model,1) ;
}



/*=========================================================================
y֐zmqoDeleteSequence
yprzMQOV[PX폜
yz
		seq		MQOV[PX

yߒlzȂ
ydlzƂĂ̓fBXvCXg̍폜Ɠ`D
=========================================================================*/

void mqoDeleteSequence(MQO_SEQUENCE seq)
{
	mqoDeleteObject(seq.model, seq.n_frame) ;
}
